/***************************************************************************
                          canvasshapes.cpp  -  description
                             -------------------
    begin                : Tue Jul 30 2002
    copyright            : (C) 2002 by Ryan Rusaw
    email                : rrusaw@sasktel.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qcanvas.h>
#include <stdio.h>
#include "canvasshapes.h"

CanvasRoundedRectangle::CanvasRoundedRectangle(int x, int y, int w, int h, int rad,  QCanvas * canvas) : QCanvasPolygon(canvas)
{
   int myx, myy, k=0;
   QPointArray mypoints;
   QPointArray arc1;
   arc1.makeArc(x+w-rad,y+rad,2*rad,2*rad, 1440 , -1440 );
   QPointArray arc2;
   arc2.makeArc(x+w-rad,y+h-rad,2*rad,2*rad, 0, -1440);
   QPointArray arc3;
   arc3.makeArc(x+rad,y+h-rad,2*rad,2*rad,-1440, -1440);
   QPointArray arc4;
   arc4.makeArc(x+rad,y+rad,2*rad,2*rad, 2880, -1440);
   for (int i = 0; i < arc1.size(); i++)
   {
     arc1.point(i,&myx,&myy);
     mypoints.putPoints(k, 1, myx, myy);
     k++;
   }
   for (int i = 0; i < arc2.size(); i++)
   {
     arc2.point(i,&myx,&myy);
     mypoints.putPoints(k, 1, myx, myy);
     k++;
   }
   for (int i = 0; i < arc3.size(); i++)
   {
     arc3.point(i,&myx,&myy);
     mypoints.putPoints(k, 1, myx, myy);
     k++;
   }
   for (int i = 0; i < arc4.size(); i++)
   {
     arc4.point(i,&myx,&myy);
     mypoints.putPoints(k, 1, myx, myy);
     k++;
   }
   outlinepoints = mypoints;
   setPoints(mypoints);
}

int CanvasRoundedRectangle::rtti() const
{
     return 1001;
}

CanvasCutEllipse::CanvasCutEllipse( int w, int h, int startangle, int arc,  QCanvas * canvas) : QCanvasPolygon(canvas)
{
   QPointArray linepoints;
   linepoints.makeArc(0,0,w,h,startangle,arc);
   outlinepoints = linepoints;
   setPoints(linepoints);
}

int CanvasCutEllipse::rtti() const
{
     return 1002;
}
