/***************************************************************************
                          pcontent.cpp  -  description
                             -------------------
    begin                : Sat Jul 13 2002
    copyright            : (C) 2002 by Ryan Rusaw
    email                : rrusaw@sasktel.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <qobject.h>
#include <qxml.h>
#include "pcontent.h"

pImage::pImage() : QObject()
{
    filename = "";
    image = NULL;
}

pXmlNode::pXmlNode() : QObject()
{
    parent = NULL;
    nodename = new QString("");
    text = new QString("");
}

pXmlNode::pXmlNode(pXmlNode *p, const QString &qName, const QXmlAttributes &attrib) : QObject()
{
    parent = p;
    nodename = new QString(qName);
    text = new QString("");
    a = attrib;
}

QString &pXmlNode::getNodeName()
{
  return *nodename;
}

QString &pXmlNode::getText()
{
  return *text;
}


pXmlNode *pXmlNode::getParent()
{
  return parent;
}

QXmlAttributes &pXmlNode::getA()
{
  return a;
}

void pXmlNode::setNodeName(const QString &name)
{
  *nodename = name;
}

void pXmlNode::setText(const QString &t)
{
  *text = t;
}

void pXmlNode::setParent(pXmlNode *node)
{
  parent = node;
}

void pXmlNode::setA(const QXmlAttributes &attr)
{
  a = attr;
}

pXmlNode *pXmlNode::findFirstChildWithName(const QString &s, bool recurse)
{
  QListIterator<pXmlNode> it(children);
  for ( ; it.current(); ++it )
  {
       pXmlNode *search = it.current();
       if (search->getNodeName() == s)
       {
            return search;
       }
  }
  QListIterator<pXmlNode> rit(children);
  if (recurse)
  {
     for ( ; rit.current(); ++rit )
     {
          pXmlNode *search = rit.current();
          pXmlNode *value = search->findFirstChildWithName(s);
          if (value != NULL)
          {
               return value;
          }
     }
  }
  return NULL;
}

pXmlNode *pXmlNode::findLastChildWithName(const QString &s, bool recurse)
{
  QListIterator<pXmlNode> it(children);
  for ( it.toLast(); it.current(); --it )
  {
       pXmlNode *search = it.current();
       if (search->getNodeName() == s)
       {
            return search;
       }
  }
  QListIterator<pXmlNode> rit(children);
  if (recurse)
  {
     for ( it.toLast(); rit.current(); --rit )
     {
          pXmlNode *search = rit.current();
          pXmlNode *value = search->findLastChildWithName(s);
          if (value != NULL)
          {
               return value;
          }
     }
  }
  return NULL;
}

pXmlNode *pXmlNode::findChildWithNameAndValue(const QString &s, const QString &qName, const QString &val, bool recurse)
{
  QListIterator<pXmlNode> it(children);
  for ( ; it.current(); ++it )
  {
       pXmlNode *search = it.current();
       if (search->getNodeName() == s)
       {           
            QXmlAttributes at = search->getA();
            if (at.value(qName) == val)
            {
               return search;
            }
       }
  }
  QListIterator<pXmlNode> rit(children);
  if (recurse)
  {
     for ( ; rit.current(); ++rit )
     {
          pXmlNode *search = rit.current();
          pXmlNode *value = search->findChildWithNameAndValue(s,qName,val);
          if (value != NULL)
          {
               return value;
          }
     }
  }
  return NULL;
}
