 /***************************************************************************
                          putils.cpp  -  description
dict.insert( -------------------
    begin                : Fri Aug 23 2002
    copyright            : (C) 2002 by Ryan Rusaw
    email                : rrusaw@sasktel.net
 ***************************************************************************/

/***************************************************************************
 *dict.insert(dict.insert(                 *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.dict.insert(       *
 *dict.insert(dict.insert(                 *
 ***************************************************************************/

 #include <qstring.h>
 #include <qimage.h>
 #include <qasciidict.h>
 #include <qarray.h>
 #include <qdatetime.h>
 #include <math.h>
 #include "putils.h"
 #include "trigtable.h"

 QAsciiDict<char> *pUtils::dict(0);
 
 pUtils::pUtils() : QObject()
 {
     if ( dict == NULL )
     {
         dict = new QAsciiDict<char>;
         dict->insert("100000000000001B0000001647831E2F","poqetp/bullets/pebble_2");
         dict->insert("100000000000001B000000167357CAA6","poqetp/bullets/pebble_1");
         dict->insert("100000000000001B000000170AB0D750","poqetp/bullets/pebble_3");
         dict->insert("100000000000001C0000002085A7BC4A","poqetp/bullets/corner_2");
         dict->insert("100000000000001C00000020BFFBFC48","poqetp/bullets/corner_4");
         dict->insert("100000000000001C00000020D876C24E","poqetp/bullets/corner_1");
         dict->insert("100000000000001C00000020E01DA237","poqetp/bullets/corner_3");
         dict->insert("100000000000001D0000001D03395BF6","poqetp/bullets/coffee_4");
         dict->insert("100000000000001D000000202156658A","poqetp/bullets/coffee_5");
         dict->insert("100000000000001E0000001E6A3E73D6","poqetp/bullets/coffee_1");
         dict->insert("10000000000000220000001B9BF7A417","poqetp/bullets/coffee_3");
         dict->insert("10000000000000220000001BD74639D4","poqetp/bullets/coffee_2");
         dict->insert("100002000000000A0000000A1F4FBE6C","poqetp/bullets/redball");
         dict->insert("100002000000000A0000000A2DB17B76","poqetp/bullets/grnball");
         dict->insert("100002000000000A0000000A37714092","poqetp/bullets/ylwball");
         dict->insert("100002000000000A0000000A70B89FEF","poqetp/bullets/grysqare");
         dict->insert("100002000000000A0000000A79785DBC","poqetp/bullets/orgsqare");
         dict->insert("100002000000000A0000000A9CD39ACD","poqetp/bullets/gryball");
         dict->insert("100002000000000A0000000AADB5EE9C","poqetp/bullets/ylwsqare");
         dict->insert("100002000000000A0000000AB5963779","poqetp/bullets/grnsqare");
         dict->insert("100002000000000A0000000AD0B8BA86","poqetp/bullets/redsqare");
         dict->insert("100002000000000A0000000ADDA84F49","poqetp/bullets/bluball");
         dict->insert("100002000000000A0000000ADFBE81A4","poqetp/bullets/blusqare");
         dict->insert("100002000000000A0000000AEF71DCFC","poqetp/bullets/orgball");
         dict->insert("100002000000000B0000000B0893AE92","poqetp/bullets/gldpearl");
         dict->insert("100002000000000B0000000BAD27F3FA","poqetp/bullets/blkpearl");
         dict->insert("100002000000000C0000000BAFBADD94","poqetp/bullets/whtpearl");
         dict->insert("100002000000000C0000000BEB60AF4D","poqetp/bullets/grnpearl");
         dict->insert("100002000000000C0000000C2B00ED21","poqetp/bullets/ylwdiamd");
         dict->insert("100002000000000C0000000C33BBCBE1","poqetp/bullets/bluered");
         dict->insert("100002000000000C0000000C424A8468","poqetp/bullets/bludiamd");
         dict->insert("100002000000000C0000000C8AB642AF","poqetp/bullets/grydiamd");
         dict->insert("100002000000000C0000000CC1013708","poqetp/bullets/rainbow");
         dict->insert("100002000000000C0000000CC1B54C41","poqetp/bullets/reddiamd");
         dict->insert("100002000000000C0000000CCE05E186","poqetp/bullets/orgdiamd");
         dict->insert("100002000000000C0000000CD0F53849","poqetp/bullets/darkblue");
         dict->insert("100002000000000C0000000CDA3C0BB5","poqetp/bullets/grndiamd");
         dict->insert("100002000000000E0000000729E60A34","poqetp/bullets/gryarrow");
         dict->insert("100002000000000E000000076BEC588A","poqetp/bullets/redarrow");
         dict->insert("100002000000000E000000078E8991EB","poqetp/bullets/ylwarrow");
         dict->insert("100002000000000E00000007944606C7","poqetp/bullets/orgarrow");
         dict->insert("100002000000000E00000007CC5BB5AB","poqetp/bullets/bluarrow");
         dict->insert("100002000000000E00000007CD436858","poqetp/bullets/grnarrow");
         dict->insert("1000020000000010000000101B5106C7","poqetp/bullets/redstar");
         dict->insert("1000020000000010000000104191C4BD","poqetp/bullets/blustar");
         dict->insert("10000200000000100000001053FE4C83","poqetp/bullets/ylwstar");
         dict->insert("100002000000001000000010AD11DC60","poqetp/bullets/grnstar");
         dict->insert("100002000000001000000010AE70CEFE","poqetp/bullets/grystar");
         dict->insert("100002000000001000000010D728D3B7","poqetp/bullets/orgstar");
         dict->insert("100002000000001000000010E156A1A9","poqetp/bullets/poliball");
         dict->insert("10000200000000110000001151CD74E2","poqetp/bullets/golfball");
         dict->insert("10000200000000120000001256ED240C","poqetp/bullets/con-blue");
         dict->insert("1000020000000012000000125F12CBB3","poqetp/bullets/con-red");
         dict->insert("1000020000000012000000126F60A49F","poqetp/bullets/con-yellow");
         dict->insert("100002000000001200000012929983B4","poqetp/bullets/con-oran");
         dict->insert("1000020000000012000000129A0CB963","poqetp/bullets/con-pink");
         dict->insert("100002000000001200000012BCC77F26","poqetp/bullets/con-lilac");
         dict->insert("100002000000001200000012D55BD994","poqetp/bullets/con-green");
         dict->insert("100002000000001200000012DE287DE5","poqetp/bullets/con-cyan");
         dict->insert("100002000000001200000012EA5D6875","poqetp/bullets/darkball");
         dict->insert("100002000000002A0000001EBED105D5","poqetp/bullets/popcorn_1");
         dict->insert("100002000000002D000000251A44B916","poqetp/bullets/popcorn_2");
         dict->insert("100000000000005E0000005D88BC2CB3","poqetp/www-back/bathroom");
         dict->insert("100000000000005E0000005E04674A24","poqetp/www-back/gregre");
         dict->insert("100000000000005E0000005E0B9DE251","poqetp/www-back/jeansblk");
         dict->insert("100000000000005E0000005E0D5BDB23","poqetp/www-back/lightblue-wet");
         dict->insert("100000000000005E0000005E104E04AB","poqetp/www-back/marble_dark");
         dict->insert("100000000000005E0000005E11ECFE5E","poqetp/www-back/structure");
         dict->insert("100000000000005E0000005E14459536","poqetp/www-back/blocks");
         dict->insert("100000000000005E0000005E14522F0B","poqetp/www-back/purple");
         dict->insert("100000000000005E0000005E17FCF091","poqetp/www-back/chocolate");
         dict->insert("100000000000005E0000005E1BFDDD0C","poqetp/www-back/wall-grey");
         dict->insert("100000000000005E0000005E2142AD0F","poqetp/www-back/sand");
         dict->insert("100000000000005E0000005E25CFE127","poqetp/www-back/structure_darkgreen");
         dict->insert("100000000000005E0000005E2AAFE172","poqetp/www-back/confetti");
         dict->insert("100000000000005E0000005E2CACE5D6","poqetp/www-back/canvas_blue");
         dict->insert("100000000000005E0000005E2DE324A7","poqetp/www-back/popcorn");
         dict->insert("100000000000005E0000005E3ECA8433","poqetp/www-back/imitation_leather");
         dict->insert("100000000000005E0000005E3EFF862E","poqetp/www-back/interstices");
         dict->insert("100000000000005E0000005E3F5CC09E","poqetp/www-back/reddark");
         dict->insert("100000000000005E0000005E54210AD7","poqetp/www-back/pool");
         dict->insert("100000000000005E0000005E5EBC925F","poqetp/www-back/pebble-light");
         dict->insert("100000000000005E0000005E65E13649","poqetp/www-back/blueblop");
         dict->insert("100000000000005E0000005E692EFEE4","poqetp/www-back/pattern");
         dict->insert("100000000000005E0000005E6EAE58C1","poqetp/www-back/fuzzy-grey");
         dict->insert("100000000000005E0000005E77ED1D0C","poqetp/www-back/citrus");
         dict->insert("100000000000005E0000005E7A93CF74","poqetp/www-back/lawn");
         dict->insert("100000000000005E0000005E8070D215","poqetp/www-back/soft-structure_grey");
         dict->insert("100000000000005E0000005E83C38521","poqetp/www-back/linen-fine");
         dict->insert("100000000000005E0000005E8A75C7DE","poqetp/www-back/pink");
         dict->insert("100000000000005E0000005E8FD26189","poqetp/www-back/ice-light");
         dict->insert("100000000000005E0000005E93CF9EE1","poqetp/www-back/fuzzy-blue");
         dict->insert("100000000000005E0000005E947BB093","poqetp/www-back/bulging");
         dict->insert("100000000000005E0000005E9C86A11C","poqetp/www-back/fuzzy_light");
         dict->insert("100000000000005E0000005EA2BC9583","poqetp/www-back/fuzzy-darkgrey");
         dict->insert("100000000000005E0000005EA7E1B7BE","poqetp/www-back/wet-turquoise");
         dict->insert("100000000000005E0000005EA97208C2","poqetp/www-back/grey");
         dict->insert("100000000000005E0000005EB1AEA1BC","poqetp/www-back/fluffy");
         dict->insert("100000000000005E0000005EBB5DA84F","poqetp/www-back/liquid-blue");
         dict->insert("100000000000005E0000005EBC7676BB","poqetp/www-back/blow_green");
         dict->insert("100000000000005E0000005EC044C0F3","poqetp/www-back/fluffy-grey");
         dict->insert("100000000000005E0000005EC1172D32","poqetp/www-back/ice-blue");
         dict->insert("100000000000005E0000005EC572E2AF","poqetp/www-back/rings-orange");
         dict->insert("100000000000005E0000005EC77E9009","poqetp/www-back/jeans");
         dict->insert("100000000000005E0000005EC98F7040","poqetp/www-back/rings-green");
         dict->insert("100000000000005E0000005ECD1B3331","poqetp/www-back/sand-light");
         dict->insert("100000000000005E0000005ED064A2B2","poqetp/www-back/stone-dark");
         dict->insert("100000000000005E0000005ED1546B4A","poqetp/www-back/mint");
         dict->insert("100000000000005E0000005ED3725D78","poqetp/www-back/cheese");
         dict->insert("100000000000005E0000005ED60D3C3C","poqetp/www-back/fuzzy-lightgrey");
         dict->insert("100000000000005E0000005EDD0800CB","poqetp/www-back/wood");
         dict->insert("100000000000005E0000005EE6021C76","poqetp/www-back/lino-green");
         dict->insert("100000000000005E0000005EF243F751","poqetp/www-back/notes");
         dict->insert("100000000000005E0000005EF67ACBDF","poqetp/www-back/structure_green");
         dict->insert("100000000000005E0000005EF7006C72","poqetp/www-back/grypaws");
         dict->insert("100000000000008000000080C489E472","poqetp/www-back/mazes");
         dict->insert("100000000000005E0000005E18D2F70E","poqetp/www-back/daisy");           // these last 8 are weird->->
         dict->insert("100000000000005E0000005E2FA489E1","poqetp/www-back/sky");             // they are ->gifs but they
         dict->insert("100000000000005E0000005E48284FC1","poqetp/www-back/stone");           // get exported on my machine
         dict->insert("100000000000005E0000005E513A4C71","poqetp/www-back/aqua");            // as ->pngs-> Included here for
         dict->insert("100000000000005E0000005E7F0C5E7C","poqetp/www-back/grey");            // safety->
         dict->insert("100000000000005E0000005E803C4F28","poqetp/www-back/roses");           //
         dict->insert("100000000000005E0000005ECB5F19AD","poqetp/www-back/lawn-artificial"); //
         dict->insert("100000000000005E0000005EE2D09D89","poqetp/www-back/space");           //
    }
 }

 QString pUtils::roman(int num, bool uppercase)
 {
      QString k = "";
      if (uppercase)
      {       
        num = genroman(num,1000,'M',&k);
        num = genroman(num,500,'D',&k);
        num = genroman(num,100,'C',&k);
        num = genroman(num,50,'L',&k);
        num = genroman(num,10,'X',&k);
        num = genroman(num,5,'V',&k);
        num = genroman(num,1,'I',&k);
        genroman(num,1,'I',&k);
      }
      else
      {
        num = genroman(num,1000,'m',&k);
        num = genroman(num,500,'d',&k);
        num = genroman(num,100,'c',&k);
        num = genroman(num,50,'l',&k);
        num = genroman(num,10,'x',&k);
        num = genroman(num,5,'v',&k);
        num = genroman(num,1,'i',&k);
        genroman(num,1,'i',&k);
      }
      return k;
 }

 int pUtils::genroman(int i, int j, char c, QString *s)
 {
      while (i>=j)
      {
           *s = *s + c;
           i = i - j;
      }
      return i;
 }

 QString pUtils::getImageName(QString *hrefname)
 {
     QString h(*hrefname);                   // href URL
     h.remove(0,10);                         // Remove "#Pictures/"
     h.remove(h.length()-4,4);               // Remove file extension
     if (!dict->find(h.latin1()))
     {
          return("poqetp/grey_square");
     }
     else
     {
          return(QString(dict->find(h.latin1())));
     }
 }

 unsigned int pUtils::intsqrt(unsigned long val)
 {
    unsigned int temp, g;
    g = 0;
    if (val >= 0x40000000) {
      g = 0x8000;
      val -= 0x40000000;
    }
    #define INNER_MBGSQRT(s)                      \
      temp = (g << (s)) + (1 << ((s) * 2 - 2));   \
      if (val >= temp) {                          \
      g += 1 << ((s)-1);                        \
      val -= temp;                              \
      }
    INNER_MBGSQRT (15)
    INNER_MBGSQRT (14)
    INNER_MBGSQRT (13)
    INNER_MBGSQRT (12)
    INNER_MBGSQRT (11)
    INNER_MBGSQRT (10)
    INNER_MBGSQRT ( 9)
    INNER_MBGSQRT ( 8)
    INNER_MBGSQRT ( 7)
    INNER_MBGSQRT ( 6)
    INNER_MBGSQRT ( 5)
    INNER_MBGSQRT ( 4)
    INNER_MBGSQRT ( 3)
    INNER_MBGSQRT ( 2)
    #undef INNER_MBGSQRT
    temp = g+g+1;
    if (val >= temp) g++;
    return g;
 }

 int pUtils::intsin(int val)
 {
     while( val < 0 ) val += 3600;
     while( val > 3600 ) val -= 3600;
     return sintable[val];
 }

 int pUtils::intcos(int val)
 {
     while( val < 0 ) val += 3600;
     while ( val > 3600 ) val -= 3600;
     return costable[val];
 }

 int pUtils::inttan(int val)
 {
     while( val < 0 ) val += 3600;
     while ( val > 3600 ) val -= 3600;
     return tantable[val];
 }
 
 int pUtils::qfsqrt(int temp)
 {
    if (temp < 0) return 0;
    if (temp >= 1000) return 1000;
    return qfarray[temp];
 }

 