/***************************************************************************
                          pzipextractor.cpp  -  description
                             -------------------
    begin                : Sat Jan 18 2003
    copyright            : (C) 2003 by Ryan Rusaw
    email                : rrusaw@sasktel.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

 #include <math.h>
 #include <stdlib.h>
 #include <unistd.h>
 #include "unzip.h"
 #include "pzipextractor.h"
 
 int pZipExtractor::openFile(const DocLnk &lnkDoc)
 {
    uf = unzOpen(lnkDoc.file().latin1());
    if ( uf == NULL )
    {
       return 0;
    }
    return 1;
 }

 QByteArray *pZipExtractor::extractFile(QString &filepath)
 {
  int err=UNZ_OK;
  unzLocateFile(uf,filepath.latin1(),0);
  QByteArray buf(WRITEBUFFERSIZE);
  QByteArray *ba = new QByteArray();
  QBuffer buffer;
  buffer.setBuffer(*ba);
  buffer.open(IO_ReadWrite);
  err = unzOpenCurrentFile(uf);
  if (err!=UNZ_OK)
  {
     return 0;
  }
  do
  {
      err = unzReadCurrentFile(uf,buf.data(),buf.size());
      if (err > 0)
      {
          buffer.writeBlock(buf.data(),err);
      }
  }
  while (err > 0);
  if (err != UNZ_OK)
  {
     return 0;
  }
  buffer.close();
  unzCloseCurrentFile(uf);
  return ba;
}