/***************************************************************************
                          pzipextractor.h  -  description
                             -------------------
    begin                : Sat Jan 18 2003
    copyright            : (C) 2003 by Ryan Rusaw
    email                : rrusaw@sasktel.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

 #ifndef PZIPEXTRACTOR_H
 #define PZIPEXTRACTOR_H

 #include <qpe/applnk.h>
 #include <qcstring.h>
 #include <qbuffer.h>
 #include "unzip.h"

 #define WRITEBUFFERSIZE (8192)
 /** \class pZipExtractor
  * \brief Wrapper class for unzip.c functions to unzip files.
  * @author Ryan Rusaw
  */
 class pZipExtractor : public QObject
 {
 public:
    /**
      * \brief Constructor
      */
          pZipExtractor(){};
    /**
      * \brief Deconstructor
      */
          ~pZipExtractor(){};
    /**
      * \brief Opens lnkDoc for uncompressing.
      */
          int openFile(const DocLnk &lnkDoc);
    /**
      * \brief Closes the current file.
      */
          int closeFile(){ unzClose(uf); };
    /**
      * \brief extracts compressed file from open file to buffer
      * @param filename filename to extract
      * @return byte array of the file.
      */
          QByteArray *extractFile(QString &filename);
 private:
    /**
      * \brief Internal unzFile for currently opened file.
      */
          unzFile uf;          
 };
 #endif