/***************************************************************************
                          render3d.cpp  -  description
                             -------------------
    begin                : Mon Sep 2 2002
    copyright            : (C) 2002 by Ryan Rusaw
    email                : rrusaw@sasktel.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "render3d.h"

Render3D::Render3D(QObject *parent, QCanvas *canvas, pXmlNode *contentroot, pXmlNode *styleroot, QList<pImage> *i)
     : RenderItems(parent, canvas, contentroot, styleroot, i)
{
}
 
void Render3D::render(pXmlNode* node)
{
   // this is where we'll handle 3D scene objects in the future.
   // for now just put a placeholder image there.
    if (!replaceitems) return;
    int x,y,w,h;
    x = (int)((findStyleProperty(node,"svg:x").remove(findStyleProperty(node,"svg:x").length()-2,2).toFloat())*CM_TO_PXL/factor);
    y = (int)((findStyleProperty(node,"svg:y").remove(findStyleProperty(node,"svg:y").length()-2,2).toFloat())*CM_TO_PXL/factor);
    w = (int)((findStyleProperty(node,"svg:width").remove(findStyleProperty(node,"svg:width").length()-2,2).toFloat())*CM_TO_PXL/factor);
    h = (int)((findStyleProperty(node,"svg:height").remove(findStyleProperty(node,"svg:height").length()-2,2).toFloat())*CM_TO_PXL/factor);
    QList<QPixmap> pml;
    QPixmap *pm = new QPixmap(); 
    QImage *temp = new QImage(Resource::loadImage("poqetp/3d_blank"));
    temp->setAlphaBuffer(TRUE);
    pm->convertFromImage(temp->smoothScale(w,h));
    pml.append(pm);
    QList<QPoint> ptl;
    ptl.append(new QPoint(0,0));
    QCanvasPixmapArray *pma = new QCanvasPixmapArray(pml, ptl);
    QCanvasSprite *sprite = new QCanvasSprite(pma,canvas());
    sprite->move(x,y);
    sprite->setZ(layer++);
    sprite->show();
}