/***************************************************************************
                          renderellipse.h  -  description
                             -------------------
    begin                : Mon Sep 2 2002
    copyright            : (C) 2002 by Ryan Rusaw
    email                : rrusaw@sasktel.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef RENDERELLIPSE_H
#define RENDERELLIPSE_H

#include "renderitems.h"

/** \class RenderEllipse
  * \brief Renders draw:ellipse and draw:circle nodes.
  * @author Ryan Rusaw
  */
 
class RenderEllipse : public RenderItems
{
public:
    /**
      * \brief Constructor.
      * @param parent Parent class.
      * @param canvas Canvas to render to
      * @param contentroot root of content file xml tree
      * @param styleroot root of style file xml tree
      * @param i QList of all the graphic items stored in the .sxi file
      */
     RenderEllipse(QObject* parent, QCanvas* canvas, pXmlNode *contentroot, pXmlNode*styleroot, QList<pImage> *i);
     /**
      * \brief Renders to canvas. Overloaded by descendents.
      * @param node node to render.
      */
     void render(pXmlNode* node);
};

#endif