/***************************************************************************
                          renderimage.cpp  -  description
                             -------------------
    begin                : Mon Sep 2 2002
    copyright            : (C) 2002 by Ryan Rusaw
    email                : rrusaw@sasktel.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "renderimage.h"
#include "rendertxt.h"

RenderImage::RenderImage(QObject *parent, QCanvas *canvas, pXmlNode *contentroot, pXmlNode *styleroot, QList<pImage> *i)
     : RenderItems(parent, canvas, contentroot, styleroot, i)
{
}

void RenderImage::render(pXmlNode* node)
{
   int x,y,w,h;
   x = (int)((findStyleProperty(node,"svg:x").remove(findStyleProperty(node,"svg:x").length()-2,2).toFloat())*CM_TO_PXL/factor);
   y = (int)((findStyleProperty(node,"svg:y").remove(findStyleProperty(node,"svg:y").length()-2,2).toFloat())*CM_TO_PXL/factor);
   w = (int)((findStyleProperty(node,"svg:width").remove(findStyleProperty(node,"svg:width").length()-2,2).toFloat())*CM_TO_PXL/factor);
   h = (int)((findStyleProperty(node,"svg:height").remove(findStyleProperty(node,"svg:height").length()-2,2).toFloat())*CM_TO_PXL/factor);
   QString fname = findStyleProperty(node,"xlink:href");
   pImage *data = images.first();
   while (((QString)"#" + data->filename) != fname)
   {
        data = images.next();
        if (data == NULL)
        {
             continue;
        }
   }
   QImage *i = data->image;
   if (!i)
   {
        i = new QImage(Resource::loadImage(pUtils::getImageName(&fname)));
   }
   showImage(x,y,w,h,i);
   ((RenderTxt*)this)->render(node);
}