/***************************************************************************
                          renderole.cpp  -  description
                             -------------------
    begin                : Fri Sep 13 2002
    copyright            : (C) 2002 by Ryan Rusaw
    email                : rrusaw@sasktel.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qlist.h> 
#include "renderole.h"
#include "rendertxt.h"

RenderOLE::RenderOLE(QObject *parent, QCanvas *canvas, pXmlNode *contentroot, pXmlNode *styleroot, QList<pImage> *i)
     : RenderItems(parent, canvas, contentroot, styleroot, i)
{
}

void RenderOLE::render(pXmlNode *node, QList<QByteArray> *objfilelist, QList<QString> *objnamelist)
{
   int x,y,w,h;
   x = (int)((findStyleProperty(node,"svg:x").remove(findStyleProperty(node,"svg:x").length()-2,2).toFloat())*CM_TO_PXL/factor);
   y = (int)((findStyleProperty(node,"svg:y").remove(findStyleProperty(node,"svg:y").length()-2,2).toFloat())*CM_TO_PXL/factor);
   w = (int)((findStyleProperty(node,"svg:width").remove(findStyleProperty(node,"svg:width").length()-2,2).toFloat())*CM_TO_PXL/factor);
   h = (int)((findStyleProperty(node,"svg:height").remove(findStyleProperty(node,"svg:height").length()-2,2).toFloat())*CM_TO_PXL/factor);

   // Parse the content and style files of the OLE object so we can render it.
   
   QString href = findStyleProperty(node,"xlink:href").remove(0,3); // remove "#./"
   QString contentfile = href + "/content.xml" ;
   PParser *handler = new PParser();
   QXmlSimpleReader reader;
   QListIterator<QString> it(*objnamelist);
   int index = 0;
   QString *emp;
   // If only objnamelist->find() would work :(
   for (int count = 0 ; it.current(); ++it )
   {
       emp = it.current();     
       if (!(emp->compare(contentfile)))
       {
           index = count;     
       }
       count++;
   }
   QTextStream ts_c( *objfilelist->at(index), IO_ReadWrite );
   QXmlInputSource source_c( ts_c );
   reader.setContentHandler( handler );
   reader.parse( source_c );
   QString stylefile = href + "/styles.xml";
   it.toFirst();
   for (int count = 0 ; it.current(); ++it )
   {
       QString *emp = it.current();
       if (!(emp->compare(contentfile)))
       {
           index = count;
       }
       count++;
   }
   QTextStream ts_s( *objfilelist->at(index), IO_ReadWrite );
   QXmlInputSource source_s( ts_s );
   reader.parse( source_s );

   QString classstr = handler->content.getA().value("office:class");
   pXmlNode * page = handler->content.findFirstChildWithName("office:body");
   if ( classstr == "text" )
   {
       RenderTxt *rt = new RenderTxt(this,canvas(),&(handler->content),&(handler->style),&(handler->images));
       rt->setFactor(factor);
       rt->setRect(new QRect(x,y,w,h));
       rt->render(page);
   }
   else
   {
       QImage *i = NULL;
       if (!i)
       {
            i = new QImage(Resource::loadImage(pUtils::getImageName(new QString(""))));
       }
       i->setAlphaBuffer(TRUE);
       showImage(x,y,w,h,i);
   }
}