/***************************************************************************
                          renderole.h  -  description
                             -------------------
    begin                : Fri Sep 13 2002
    copyright            : (C) 2002 by Ryan Rusaw
    email                : rrusaw@sasktel.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef RENDEROLE_H
#define RENDEROLE_H

#include <renderitems.h>

/** \class RenderOLE
  * \brief Renders draw:object nodes.
  * @author Ryan Rusaw
  */

class RenderOLE : public RenderItems  {
public:
    /**
      * \brief Constructor.
      * @param parent Parent class.
      * @param canvas Canvas to render to
      * @param contentroot root of content file xml tree
      * @param styleroot root of style file xml tree
      * @param i QList of all the graphic items stored in the .sxi file
      */ 
	   RenderOLE(QObject *parent, QCanvas *canvas, pXmlNode *contentroot, pXmlNode *styleroot, QList<pImage> *i);
    /**
      * \brief Renders to canvas.
      * @param node node to render.
      * @param objfilelist list of QByteArrays that are the uncompressed files.
      * @param objnamelist list of names of contained OLE files.
      */
     void render(pXmlNode *node, QList<QByteArray> *objfilelist, QList<QString> *objnamelist);
};

#endif
