/***************************************************************************
                          rendertxt.h  -  description
                             -------------------
    begin                : Mon Sep 2 2002
    copyright            : (C) 2002 by Ryan Rusaw
    email                : rrusaw@sasktel.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef RENDERTXT_H
#define RENDERTXT_H
 
#include "renderitems.h"

/** \class RenderTxt
  * \brief renders draw:text-box nodes and text from other nodes.
  * @author Ryan Rusaw
  */
 
class RenderTxt : public RenderItems
{
public:
    /**
      * \brief Constructor.
      * @param parent Parent class.
      * @param canvas Canvas to render to
      * @param contentroot root of content file xml tree
      * @param styleroot root of style file xml tree
      * @param i QList of all the graphic items stored in the .sxi file
      */ 
     RenderTxt(QObject *parent, QCanvas *canvas, pXmlNode *contentroot, pXmlNode *styleroot, QList<pImage> *i);
    /**
      * \brief Renders to canvas.
      * @param node node to render.
      * @param clearlinecount Clears internal line count when true
      */
     void render(pXmlNode *node, bool clearlinecount = true );
};

#endif